--Table
GameState = {}

--New
function GameState:new()
	local gs = {}

	gs = setmetatable(gs, self)
	self.__index = self
	_gs = gs
	
	return gs
end

--Load
function GameState:load()
	ArenaBackground = love.graphics.newImage("TurtleWarsGamebackground.png")
	
	debugString = "Round 1!"
	
	numEnt = 1
	currentEntity = 0
	PlayerTurtleLvl1 = love.graphics.newImage("TurtleLvl1.png")
	EnemyTurtleLvl1 = love.graphics.newImage("EnemyTurtleLvl1.png")
	
	turtles = {}
	spawnTurtles("player", 200, "Lvl1", 200, 300)
end


--Spawn Turtles
function spawnTurtles(type, speed, level, x, y)
	local i = {}
	i.type = type
	i.x, i.y = x, y
	i.id = (numEnt)
	i.speed = speed
	numEnt = numEnt + 1
	
	if i.type == "player" then
		if level == "Lvl1" then
			i.image = PlayerTurtleLvl1
		end
	end
	
	table.insert(turtles, i)
end

-- Draws Turtles
function drawTurtles()
	for i,v in ipairs(turtles) do
		love.graphics.draw(v.image, v.x, v.y)
	end
end

function updateTurtles(dt)
	for i,v in ipairs(turtles) do
		if v.type == "player" then
			if love.keyboard.isDown("w") then
				v.y = v.y - v.speed * dt
			end
			if love.keyboard.isDown("s") then
				v.y = v.y + v.speed * dt
			end
			if love.keyboard.isDown("a") then
				v.x = v.x - v.speed * dt
			end
			if love.keyboard.isDown("d") then
				v.x = v.x + v.speed * dt
			end
		end
	end
end

--Close
function GameState:close()
end

--Enable
function GameState:enable()
end

--Disable
function GameState:disable()
end

--Update
function GameState:update(dt)
	updateTurtles(dt)
end

--Draw
function GameState:draw()
	love.graphics.draw(ArenaBackground, 0, 0)
	love.graphics.print(debugString, 0, 0)
	
	drawTurtles()
end

--KeyPressed
function GameState:keypressed(key, unicode)
end

--KeyRelease
function GameState:keyrelease(key, unicode)
end

--MousePressed
function GameState:mousepressed(x, y, button)
end

--MouseReleased
function GameState:mousereleased(x, y, button)
end

